=== debian/changelog ===
qemu-web-desktop (26.01.08+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 26.01.08+ds1

  [ Picca Frédéric-Emmanuel ]
  Bump debhelper from old 12 to 13.
  Set debhelper-compat version in Build-Depends.
  d/salsa-ci.yml: Added and de-activated i386 build.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 11 Jan 2026 13:35:02 +0100
