## qemu-web-desktop 26.02.08+ds1

=== debian/changelog ===
qemu-web-desktop (26.02.08+ds1-1) unstable; urgency=medium

  * New upstream version 26.02.08+ds1
  * d/apache2: use dh_apache2 heuristic mode
  * d/control: Only amd64 and arm64 are supported for now
  * d/control: use dh-sequence-installsysusers
  * d/control: Fix my email
  * d/copyright: fix Files-Excluded with the new upstream organisation
  * d/manpages: The make file take care of this
  * d/rules: simplify now that the make file is doing everythongs for us
  * d/rules: skip test for now

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Feb 2026 15:51:31 +0100
