=== debian/control ===
Source: qemu-web-desktop
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>,
           Emmanuel Farhi <emmanuel.farhi.1@gmail.com>,
           Picca Frédéric-Emmanuel <picca@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-apache2,
               dh-sequence-installsysusers,
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/debian/qemu-web-desktop
Vcs-Git: https://salsa.debian.org/debian/qemu-web-desktop.git
Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop

Package: qemu-web-desktop
Architecture: amd64 arm64
Depends: bridge-utils,
         confget | crudini,
         dnsmasq,
         guestfs-tools,
         iptables,
         libapache2-mod-perl2,
         libapache2-mpm-itk,
         libcgi-pm-perl,
         libemail-valid-perl,
         libjson-perl,
         liblist-moreutils-perl,
         libmail-imapclient-perl,
         libnet-dns-perl,
         libnet-ldap-perl,
         libnet-smtps-perl,
         libnet-ssh2-perl,
         libproc-background-perl,
         libproc-processtable-perl,
         libsys-cpu-perl,
         libsys-cpuload-perl,
         libsys-meminfo-perl,
         libtext-qrcode-perl,
         novnc,
         qemu-system-arm [arm64],
         qemu-system-x86 [amd64],
         websockify,
         wget,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ${misc:Recommends}
Suggests: qemu-system
Description: Remote desktop service with virtual machines in a browser (DARTS).
 A remote desktop service that launches virtual machines and displays
 them in your browser. Place virtual machine files (ISO, QCOW2, VDI,
 VMDK...) into /var/lib/qemu-web-desktop/machines, add their names in
 the /etc/qemu-web-desktop/machines.conf file (use: qwdctl edit machines),
 and run: qwdctl refresh.
 You can tune the service settings in the
 /etc/qemu-web-desktop/config.pl (use: qwdctl edit config).
 This project is also named Data Analysis Remote Treatment Service (DARTS).
 .
 Once installed, connect to http://server/qemu-web-desktop
