=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# to remove once upstream fix the Makefile
override_dh_auto_clean:
	rm -rf html/desktop/machines
	dh_auto_clean

# to remove once upstream fix the Makefile
override_dh_auto_build:
	mkdir -p html/desktop/machines
	touch html/desktop/machines/README
	dh_auto_build

#override_dh_auto_build:
#	mkdir -p build/etc
#	cp etc/apache.conf build/etc/qemu-web-desktop.conf

override_dh_auto_test:
