## qemu-web-desktop 26.03.02+ds1

=== debian/changelog ===
qemu-web-desktop (26.03.02+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 26.03.02+ds1

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Mon, 02 Mar 2026 11:28:09 +0100

qemu-web-desktop (26.02.08+ds1-2) unstable; urgency=medium

  * d/postinst: remove useless call to apache2-maintscript-helper

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Feb 2026 17:11:15 +0100
