## qemu-web-desktop 26.03.03+ds1

=== debian/changelog ===
qemu-web-desktop (26.03.03+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 26.03.03+ds1
  * fix reverse proxy (apache/websockify)

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Tue, 03 Mar 2026 08:49:38 +0100
